import type { Graph, Node, NodeConectionSchema, NodeTypeSchema, ViewerState, GraphBuilder, GraphViewer } from "./types";
export declare const initGraph: () => Graph;
export declare const addNodeType: (graph: Graph) => (schema: NodeTypeSchema) => {
    nodeSchema: NodeTypeSchema[];
    graphSchema: import("./types").GraphSchema;
    nodes: Node[];
    adjacencyList: Record<string, string[]>;
};
export declare const updateNodeType: (graph: Graph) => (schema: NodeTypeSchema) => {
    nodeSchema: NodeTypeSchema[];
    graphSchema: import("./types").GraphSchema;
    nodes: Node[];
    adjacencyList: Record<string, string[]>;
};
export declare const removeNodeType: (graph: Graph) => (type: string) => {
    nodeSchema: NodeTypeSchema[];
    graphSchema: import("./types").GraphSchema;
    nodes: Node[];
    adjacencyList: Record<string, string[]>;
};
export declare const addConnectionType: (graph: Graph) => (connection: NodeConectionSchema) => {
    graphSchema: {
        connections: NodeConectionSchema[];
    };
    nodeSchema: NodeTypeSchema[];
    nodes: Node[];
    adjacencyList: Record<string, string[]>;
};
export declare const removeConnectionType: (graph: Graph) => (connection: NodeConectionSchema) => {
    graphSchema: {
        connections: NodeConectionSchema[];
    };
    nodeSchema: NodeTypeSchema[];
    nodes: Node[];
    adjacencyList: Record<string, string[]>;
};
export declare const addConnection: (graph: Graph) => (connection: NodeConectionSchema) => {
    adjacencyList: {
        [x: string]: string[];
    };
    nodeSchema: NodeTypeSchema[];
    graphSchema: import("./types").GraphSchema;
    nodes: Node[];
};
export declare const removeConnection: (graph: Graph) => (connection: NodeConectionSchema) => {
    adjacencyList: Record<string, string[]>;
    nodeSchema: NodeTypeSchema[];
    graphSchema: import("./types").GraphSchema;
    nodes: Node[];
};
export declare const createNode: (node: Omit<Node, "id">) => Node;
export declare const addNode: (graph: Graph) => (node: Node) => {
    nodes: Node[];
    nodeSchema: NodeTypeSchema[];
    graphSchema: import("./types").GraphSchema;
    adjacencyList: Record<string, string[]>;
};
export declare const removeNode: (graph: Graph) => (id: string) => Graph;
export declare const graphBuilder: (graph?: Graph) => GraphBuilder;
export declare const getVisibleNodes: (graph: Graph) => (revealed: string[]) => string[];
export declare const getVisibleChildren: (graph: Graph, visible: string[]) => (id: string) => Node[];
export declare const queryType: (nodes: Node[], type: string) => Node[];
export declare const revealNodes: (viewerState: ViewerState) => (ids: string[]) => {
    revealed: string[];
};
export declare const hideNodes: (viewerState: ViewerState) => (ids: string[]) => {
    revealed: string[];
};
export declare const getNodeById: (nodes: Node[]) => (id: string) => Node;
export declare const graphViewer: (graph: Graph) => (viewerState?: {
    revealed: string[];
} | undefined) => GraphViewer;
export * from "./error";
export * from "./types";
//# sourceMappingURL=index.d.ts.map